﻿local mod = RW:Boss("Karsh Steelbender", "Party - Cataclysm", "Blackrock Caverns")
local L

mod.type = "party"

mod.bossIcon = [[Interface\ICONS\TEMP]]

---------------------------
-- Variables

-- Obsidian Armor
local wArmor

-- Heated Armor
local tHeatedDur

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.heated_frame = "Show frame for Superheated Obsidian Armor"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(39698)
	self:SetWin()
	
	self:AddBoolOption("HeatedStacks",  L.heated_frame, nil, nil, select(3, GetSpellInfo(75846)))
	
	wArmor			= mod:Warning(75842)
	
	tHeatedDur		= mod:DurStackTimer(10, 75846)
end

---------------------------
-- Locals
local HeatedSpell = GetSpellInfo(75846)
local HeatedStacks
local HeatedUpdate

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("ObsidianArmor", 75842)
	self:TrackAura("HeatedArmor", 75846)
	
	HeatedStacks = 0
end

function mod:ObsidianArmor(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wArmor:Show()
	end
end

function mod:HeatedArmor(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		HeatedStacks = args.amount or 0
		tHeatedDur:Start(0, HeatedStacks)
		if args.amount == 1 and self.db.profile.HeatedStacks then
			self:SendMessage("RW_AddHealthFrame", HeatedUpdate, furySpell, select(3, GetSpellInfo(75846)), "STACK")
		end
		
	elseif event == "SPELL_AURA_REMOVED" then
		HeatedStacks = 0
		self:SendMessage("RW_RemoveHealthFrame", HeatedUpdate)
	end
end


HeatedUpdate = function()
	return HeatedUpdate, 20
end