local mod = RW:Boss("Faction Champions", "Party - WOTLK", "Trial of the Champion")
local L

mod.type = "party"

mod.BossIcon = [[Interface\Icons\INV_Spear_05]]
mod.SubCatIcon = [[Interface\Icons\Achievement_Dungeon_GloryoftheRaider]]

local mHeal = nil
local mHex = nil
local mPoly = nil
local mPoison = nil

local phase = 1
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.win = "Well fought! Your next challenge comes from the Crusade's own ranks. You will be tested against their considerable prowess."
	end
	L = mod:GetLocale()
	self.L = L
	self:SetTrigger(34657, 34701, 34702, 34703, 34705,35004, 35005,35569, 35570, 35571, 35572, 35617)
	self:SetWin(L.win)
	mHeal = self:CastMessage(68318)
	mHex = self:TargetMessage(67534)
	mPoly = self:TargetMessage(66043)
	mPoison = self:TargetMessage(67701)
end

function mod:OnEngage(trigger)
	self:TrackAura("Hex", 67534)
	self:TrackAura("Poly",66043,68311)
	self:TrackAura("Poison",67701, 67594, 68316)
	self:TrackCastStart("ShamanHealing",68318, 67528)
	self:TrackCast("PhaseChange",64460,67891,69639,43979,43978,25840,39334,39335,17683)
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
end

function mod:PLAYER_REGEN_DISABLED()
	if phase == 2 then
		self:ToggleHold()
		self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	end
end

function mod:PhaseChange(event,args)
	if phase == 1 then
		self:ToggleHold()
		phase = 2
	end
end

function mod:Hex(applied, args)
	if applied then
		mHex:Show(args.dName)
	end
end

function mod:Poly(applied, args)
	if applied then
		mPoly:Show(args.dName)
	end
end

function mod:Poison(applied, args)
	if applied and args.dName == self.pName then
		mPoison:Show(args.dName)
	end
end

function mod:ShamanHealing(args)
	mHeal:Show()
end